int Cnext[4096][4096];
int Cprev[4096][4096];
int Rnext[4096][4096];
int Rprev[4096][4096];
int Cfirst[4096];
int Clast[4096];
int Rfirst[4096];
int Rlast[4096];


/* Eintrage sind maximal pattern size: 256, alerdings ist 255:=leer */
unsigned char wave_flags[3][4096][4096];

char W[256][256];
char T[256][256];
int mp[256];
unsigned TWITNESS[256][256];
unsigned BWITNESS[256][256];
unsigned S[65536];
unsigned Scount=0;

extern void removeCi(int i, int row);
extern void removeRj(int j, int col);


/* TWO PATTERN OUT */
void two_pattern_out(int x, int y) {
	/* draw two pattern with translation (x,y) */
	int xp,yp,i;

	putchar(' ');
	putchar('|');
	for(i=0; i<m; i++)
		printf("%i",i%10);
	for(i=0; i<y; i++)
		putchar(' ');
	putchar('|');
	putchar('\n');
	putchar('-');
	putchar('+');
	for(i=0; i<m+y; i++)
		putchar('-');
	putchar('+');
	putchar('-');
	putchar('\n');
	xp=0;
	i=0;	
	while(xp > x) {
		putchar(' ');
		putchar('|');
		for(yp=0; yp<y; yp++)
			putchar(' ');
		printf("%s|%i\n",pattern[i],i%10);
		i++;
		xp--;
	}
	xp=0;
	while(xp < m) {
		printf("%i|",xp%10);
		yp=0;
		while(yp < m) {
			if(xp-x >= 0 && yp-y >= 0 && xp-x < m && yp-y <m) {
				if(pattern[xp][yp] != pattern[xp-x][yp-y]) {
					putchar('#');
				} else {
						putchar(pattern[xp][yp]);
				}
			} else {
					putchar(pattern[xp][yp]);
			}
			yp++;
		}
		while(xp-x >= 0 && yp-y < m) {
			putchar(pattern[xp-x][yp-y]);
			yp++;
		}
		if(xp-x < m && xp-x >= 0) {
			printf("|%i",(xp-x)%10);
		} else {
			for(i=0; i<y; i++)
				putchar(' ');
			putchar('|');
		}
		putchar('\n');
		xp++;	
	}
	while(xp-x < m && yp-y >= 0) {
		putchar(' ');
		putchar('|');
		for(i=0; i<y; i++)
			putchar(' ');
		yp=0;
		while(xp-x >= 0 && yp-y < m) {
			putchar(pattern[xp-x][yp-y]);
			yp++;
		}
		printf("|%i",(xp-x)%10);
		putchar('\n');
		xp++;
	}
	putchar('-');
	putchar('+');
	for(i=0; i<=m+y-1; i++)
		putchar('-');
	putchar('+');
	putchar('-');
	putchar('\n');
	putchar(' ');
	putchar('|');
	for(i=0; i<=y-1; i++)
		putchar(' ');
	for(i=0; i<m; i++)
		printf("%i",i%10);
	putchar('|');
	putchar('\n');
}

/* CHECK WITNESS */
int check_witness(int x, int y, int xw, int yw) {
	/* check if witness is true */
	/* WITNESS[x,y]=(xw,yw) */
	if(x<m && y<m && x+xw<m && y+yw<m) {
		if(pattern[xw][yw] == pattern[x+xw][y+yw]) {
			printf("***ERROR*** WITNESS[%i,%i] IS NOT (%i,%i)\n",x,y,xw,yw);
		} else {
			printf("WITNESS[%i,%i]=(%i,%i)\n",x,y,xw,yw);
		}
	} else {
		if(x<m && y<m && xw == m && yw == m)
			printf("SOURCE AT [%i,%i] ?\n",x,y);
		else
			printf("Out of range!\n");
		return(-1);
	}
}

/* PREFIX_LEN */
int prefix_len(char *s1,char *s2) {
	/* Bestimmung der Laenge des laengsten gemeinsamen Prefix */
	int i1;

	i1=0;
	while(*s1==*s2 && *s1 != (char)NULL && *s2 != (char)NULL) {
		i1++;
		s1++;
		s2++;
	}
	return(i1);
}

/* SERIAL WITNESS */
void seriell_witness() {
	/* Berechnung der Witness-Table nach dem seriellen Algorithmus */
	int j,i,wi,l;
	char *z1;

	/* === TOP WITNESS === */
	for(j=0; j<m; j++) {
		/* Arrays W und T erstellen */
		for(i=0; i<m; i++) {
			strcpy(W[i],pattern[i]);
			W[i][m-j]=(char)NULL;
			z1=pattern[i];
			z1+=j;
			strcpy(T[i],z1);
		}
		
		/* max_prefix mp bestimmen */
		for(i=0; i<m; i++) {
			mp[i]=0;
			for(wi=0; wi<m; wi++) {
				if(strcmp(W[wi],T[i+wi]) == 0)
					mp[i]++;
				else
					break;
			}
		}

		/* Berechnung der Witness */
		for(i=0; i<m; i++) {
			if(mp[i]==m-i) {
				TWITNESS[i][j]=m*1000+m;
#ifdef debug
				check_witness(i,j,m,m);
#endif
			} else {
				l=prefix_len(T[i+mp[i]],W[mp[i]]);
				TWITNESS[i][j]=mp[i]*1000+l;
#ifdef debug
				check_witness(i,j,mp[i],l);
#endif
			}
		}
	}	

	/* === BOTTOM WITNESS === */
	for(j=0; j<m; j++) {
		/* Arrays W und T erstellen, diesmal die letzte Zeile vom Pattern zuerst */
		for(i=0; i<m; i++) {
			strcpy(W[m-i-1],pattern[i]);
			W[m-i-1][m-j]=(char)NULL;
			z1=pattern[i];
			z1+=j;
			strcpy(T[m-i-1],z1);
		}

		/* max_prefix mp bestimmen, wie bei TW, damit automatisch andersrum */
		for(i=0; i<m; i++) {
			mp[i]=0;
			for(wi=0; wi<m; wi++) {
				if(strcmp(W[wi],T[i+wi]) == 0)
					mp[i]++;
				else
					break;
			}
		}

		/* Berechnung der Witness, andere erste Koordiante */
		for(i=0; i<m; i++) {
			if(mp[i]==m-i) {
				BWITNESS[i][j]=m*1000+m;
#ifdef debug
				check_witness((-1)*i,j,m,m);
#endif
			} else {
				l=prefix_len(T[i+mp[i]],W[mp[i]]);
				BWITNESS[i][j]=(m-mp[i]-1)*1000+l;
#ifdef debug
				check_witness((-1)*i,j,m-mp[i]-1,l);
#endif
			}
		}
	}
}

/* col cons check */
unsigned col_cons_check(unsigned r,unsigned x) { 
	if(x-r >= m) {	// the patterns dont overlap 
		return(1000*m+m);	// always consistent
	} else {
		return(TWITNESS[x-r][0]);
	}
}

/* PRINT S OUT */
void print_S_out(int c) {
	unsigned u1;

  for(u1=1; u1<=Scount; u1++) {
    printf("(%u,%u) -> ",S[u1],c);
  }
	putchar('\n');
}

/* ALGORITHMUS B - PROCESS COL */
void process_col(int c) {
	unsigned x;	
	unsigned nowit=1000*m+m;
	unsigned wit,wit_i,wit_j;
	char char_p1,char_p2,char_t;
	int rerun;
	long int r;	/* we want to have at least 65536 entrys, but no overroll at 0 */

	/* Beachte: Da hier c fest gewaelt ist, genuegt es die row-Anteile in S zu speichern! */

	/* if Scount == 0 the S is empty! */
	/* for performance, don't use S[0] */
	Scount=0;
	
	/* initialise S */
	Scount=1;
	S[Scount]=(n-m);

	/* for all r from m-n-1 to 0 */
	for(r = n-m-1; r >= 0; r--) {
#ifdef DEBUG
		printf("\nr=%u\n",r);
#endif
		rerun=1;
		while(rerun==1) {
			rerun=0;
			/* (x,c) is the top entry of S */
			x=S[Scount];
			/* check (r,c) and (x,c) for consistency */
			wit=col_cons_check(r,x);
#ifdef DEBUG
			printf("m=%u - TW[x-r,0]=TW[%u,0]=%u\n",m,x-r,wit);
#endif
			if(wit == nowit) {	/* consistent */
				/* (r,c) to the top of S */
				if(S[Scount]!=r) {
					Scount++;
					S[Scount]=r;	
#ifdef DEBUG
				} else {
					printf("no double entrys!\n");
#endif
				}
			} else {	/* not consistent */
				/* use witness entry to check which pattern matches the text */
				wit_i=wit/1000;		/* in the witness_table the notation ist i*1000+j */
				wit_j=wit%1000;
				char_p1=pattern[wit_i][wit_j];	/* char from pattern at top of S: (x,c) */
				char_p2=pattern[x-r+wit_i][0+wit_j];	/* char from "new" pattern: (r,c) */
				char_t=text[x+wit_i][c+wit_j];	/* char in the text */
#ifdef DEBUG
				printf("Pattern bei (x,c): \"%c\"\n",char_p1);
				printf("Pattern bei (r,c): \"%c\"\n",char_p2);
				printf("Text: \"%c\"\n",char_t);
#endif
				if(char_p1 != char_t) {
					/* remove (x,c) from S if not matching the text*/
					Scount--;
					/* if (r,c) not removed, the again the consistency check */
					if(char_p2 == char_t) {
						rerun=1;
					}
				}

				/* if S is empty, put (r,c) to the top of S */
				if(Scount == 0) {
					Scount++;
					S[Scount]=r;
					rerun=0;
				}
			}
		}
#ifdef DEBUG 
	print_S_out(c);
#endif
	}
}

/* TOP DOWN */
void top_down(int c) {
	int i1,i,j,i2;
	int cur,row,lft;
	unsigned cons;
	unsigned tcur;
	unsigned tlft;
	unsigned ttext;

#ifdef DEBUG
	printf("Top_down(%i)\n",c);
#endif

	row=0;
	cur=Cfirst[c];
	while(cur >= 0 ) {
#ifdef DEBUG
		printf("c=%i - Cur=%i - row=%i\n",c,cur,row);
#endif

		/* bestimme naechstes lft */
		lft=Rfirst[row];
		if(lft == -1) {
			/* Rrow leer */
			row++;
		} else {
#ifdef DEBUG
			printf("\nVergleiche cur=(%i,%i) mit lft=(%i,%i)\n",cur,c,row,lft);
#endif

			/* Hier gilt cur=(cur,c) und lft=(row,lft) */

#ifdef DEBUG
			printf("WITNESS[%i,%i]\n",row-cur,lft-c);
#endif

			if(cur-row >= 0 && cur-row < m && lft-c >= 0 && lft-c < m)
				cons=BWITNESS[cur-row][lft-c];
			else
				cons=m*1000+m;
			if(cons == m*1000+m || lft == -1) { /* Konsistent oder Rrow leer */
				row++;  /* fahre mit der nchsten zeile fort */
#ifdef DEBUG
				printf("TD-KONSISTENT: %u\n",cons);
#endif
			} else {
#ifdef DEBUG
				printf("NICHT: %u\n",cons);
#endif
				i=cons/1000;
				j=cons%1000;
				tcur=pattern[i-(cur-row)][j+(lft-c)];
				tlft=pattern[i][j];
				ttext=text[i+row][j+lft];

#ifdef DEBUG
				printf("Text: %c - cur: %c - lft: %c\n",ttext,tcur,tlft);
#endif
				if(ttext != tlft) {
					/* entferne lft aus Rrow */
#ifdef DEBUG
					printf("TD: Entferne (%i,%i) aus den Listen\n",row,lft);
#endif

					removeCi(lft,row);
					removeRj(row,lft);
				}
				if(ttext != tcur) {
					/* entferne cur aus Cc und nehme nchsten cur */
#ifdef DEBUG
					printf("TD: Entferne (%i,%i) aus Ci\n",cur,c);
#endif
					i2=cur;
					cur=Cnext[c][cur];
					removeCi(c,i2);
				}
			}

		}
		if(cur >= 0 && row>cur) {   /* row ueber cur, dann naechstes cur */
			cur=Cnext[c][cur];
		}
	}
}

/* BOTTOM UP */
void bottom_up(int c) {
	int i1,i,j,i2;
	int cur,row,lft;
	unsigned cons;
	unsigned tcur;
	unsigned tlft;
	unsigned ttext;

#ifdef DEBUG
	printf("Bottom_up(%i)\n",c);
#endif

	row=n-m;
	cur=Clast[c];
	while(cur >= 0) {
		lft=Rfirst[row];

		if(lft == -1) {
			/* Rrow leer, naechste row */
			row--;
		} else {
#ifdef DEBUG
				printf("\nVergleiche cur=(%i,%i) mit lft=(%i,%i)\n",cur,c,row,lft);
#endif

			/* Hier gilt cur=(cur,c) und lft=(row,lft) */

			if(row-cur >= 0 && row-cur < m && lft-c >= 0 && lft-c < m)
				cons=TWITNESS[row-cur][lft-c];
			else
				cons=m*1000+m;

			if(cons == m*1000+m ) {	/* konsistent */
				row--;	/* fahre mit der nchsten zeile fort */
#ifdef DEBUG
				printf("BU-KONSISTENT\n");
#endif
			} else { /* nicht konsistent */
#ifdef DEBUG
				printf("NICHT: %u\n",cons);
#endif
				i=cons/1000;
				j=cons%1000;
				tcur=pattern[i+(row-cur)][j+(lft-c)];
				tlft=pattern[i][j];
				ttext=text[i+row][j+lft];

#ifdef DEBUG
				printf("Text: %c - cur: %c - lft: %c\n",ttext,tcur,tlft);
#endif
				if(ttext != tlft) {
					/* entferne lft aus Rrow */
#ifdef DEBUG
				printf("BU: Entferne (%i,%i) aus den Listen\n",row,lft);
#endif
					removeCi(lft,row);
					removeRj(row,lft);
				}
				if(ttext != tcur) {
					/* entferne cur aus Cc und nehme nchsten cur */
#ifdef DEBUG
					printf("BU: Entferne (%i,%i) aus Ci\n",cur,c);
#endif
					i2=cur;
					cur=Cnext[c][cur];
					removeCi(c,i2);
				}
			}
		}
		if(cur >= 0 && row<cur) 	/* row ueber cur, dann naechstes cur */
			cur=Cnext[c][cur];
	}
}

/* init the C_i and R_j lists */
void init_lists() {
	int i1,i2;

	for(i1=0; i1<4096; i1++) {
		Cfirst[i1]=-1;
		Clast[i1]=-1;
		Rfirst[i1]=-1;
		Rlast[i1]=-1;
		for(i2=0; i2<4096; i2++) {
			Cnext[i1][i2]=-1;
			Cprev[i1][i2]=-1;
			Rnext[i1][i2]=-1;
			Rprev[i1][i2]=-1;
		}
	}
}

/* insert Element in column list C_i */
void insertCi(int i, int row) {
	int i1,i2;

	/* doppelte am Anfang oder Ende gleich verwerfen */
	if(row == Cfirst[i] || row == Clast[i])
		return;

	/* der Erste Eintrag */
	if(Cfirst[i] == -1 && Clast[i] == -1) {
		Cfirst[i]=row;
		Clast[i]=row;
		return;
	}

	if(Cfirst[i] == -1) {
		/* element is the first element */
		Cfirst[i]=row;
		Clast[i]=row;
	} else {
		/* element is not the first element */
		if(row < Cfirst[i]) {
			/* der neue erste */
			Cnext[i][row]=Cfirst[i];
			Cprev[i][Cfirst[i]]=row;
			Cfirst[i]=row;
		} else {
			if(row > Clast[i]) {
				Cnext[i][Clast[i]]=row;
				Cprev[i][row]=Clast[i];
				Clast[i]=row;
			} else {
				i1=Cfirst[i];
				while(i1<row)
					i1=Cnext[i][i1];
				/* i1 ist nun hinter row */
				i2=Cprev[i][i1];
				/* i2 ist nun vor row */

				/* doppelte vermeiden */
				if(i1 == row || i2 == row)
					return;
			
				Cnext[i][row]=i1;
				Cnext[i][i2]=row;
				Cprev[i][i1]=row;
				Cprev[i][row]=i2;
				
			}
		}
	}

}

/* remove Element in column list C_i */
void removeCi(int i, int row) {
	int i1,i2;

	/* unbekannte eintraege */
	if(row < Cfirst[i] || row > Clast[i])
		return;

	if((Cfirst[i] == Clast[i]) && (Cfirst[i] == row)) {
		Cfirst[i]=-1;
		Clast[i]=-1;
		return;
	}

	if(row == Cfirst[i]) {
		i1=Cfirst[i];
		Cfirst[i]=Cnext[i][Cfirst[i]];
		Cnext[i][i1]=-1;
		Cprev[i][Cfirst[i]]=-1;
	} else {
		if(row == Clast[i]) {
			i1=Clast[i];
			Clast[i]=Cprev[i][Clast[i]];
			Cnext[i][Clast[i]]=-1;
			Cprev[i][i1]=-1;
		} else {
			i1=Cfirst[i];
			while(i1 < row) 
				i1=Cnext[i][i1];	
			/* i1 nun auf row falls es existiert */
			if(i1 != row)
				return;
			i2=Cprev[i][i1];
			/* i2 nun vor row */
			i1=Cnext[i][i1];
			/* i1 nun hinter row */
			
			Cnext[i][i2]=i1;
			Cprev[i][i1]=i2;
			Cnext[i][row]=-1;
			Cprev[i][row]=-1;
		}
	}
}

/* print Ci */
void printCi(int i) {
	int i1;

	i1=Cfirst[i];
	if(i1 == -1) {
		return;
	}

	printf("C%i",i);
	while(i1 != -1) {
		printf(" -> (%i,%i)",i1,i);
		i1=Cnext[i][i1];
	}

	putchar('\n');
	
}

/* insert Element in row list R_j */
void insertRj(int j, int col) {
  int i1,i2;

  /* doppelte am Anfang oder Ende gleich verwerfen */
  if(col == Rfirst[j] || col == Rlast[j])
    return;

  /* der Erste Eintrag */
  if(Rfirst[j] == -1 && Rlast[j] == -1) {
    Rfirst[j]=col;
    Rlast[j]=col;
    return;
  }

  if(Rfirst[j] == -1) {
    /* element is the first element */
    Rfirst[j]=col;
    Rlast[j]=col;
  } else {
    /* element is not the first element */
    if(col < Rfirst[j]) {
      /* der neue erste */
      Rnext[j][col]=Rfirst[j];
      Rprev[j][Rfirst[j]]=col;
      Rfirst[j]=col;
    } else {
      if(col > Rlast[j]) {
        Rnext[j][Rlast[j]]=col;
        Rprev[j][col]=Rlast[j];
        Rlast[j]=col;
      } else {
        i1=Rfirst[j];
        while(i1<col)
          i1=Rnext[j][i1];
        /* i1 ist nun hinter col */
        i2=Rprev[j][i1];
        /* i2 ist nun vor col */

        /* doppelte vermeiden */
        if(i1 == col || i2 == col)
          return;

        Rnext[j][col]=i1;
        Rnext[j][i2]=col;
        Rprev[j][i1]=col;
        Rprev[j][col]=i2;

      }
    }
  }

}

/* remove Element in row list R_j */
void removeRj(int j, int col) {
  int i1,i2;
  /* unbekannte eintraege */
  if(col < Rfirst[j] || col > Rlast[j])
    return;

  if((Rfirst[j] == Rlast[j]) && (Rfirst[j] == col)) {
    Rfirst[j]=-1;
    Rlast[j]=-1;
    return;
  }

  if(col == Rfirst[j]) {
    i1=Rfirst[j];
    Rfirst[j]=Rnext[j][Rfirst[j]];
    Rnext[j][i1]=-1;
    Rprev[j][Rfirst[j]]=-1;
  } else {
    if(col == Rlast[j]) {
      i1=Rlast[j];
      Rlast[j]=Rprev[j][Rlast[j]];
      Rnext[j][Rlast[j]]=-1;
      Rprev[j][i1]=-1;
    } else {
      i1=Rfirst[j];
      while(i1 < col)
        i1=Rnext[j][i1];
      /* i1 nun auf col falls es existiert */
      if(i1 != col)
        return;
      i2=Rprev[j][i1];
      /* i2 nun vor col */
      i1=Rnext[j][i1];
      /* i1 nun hinter col */

      Rnext[j][i2]=i1;
      Rprev[j][i1]=i2;
      Rnext[j][col]=-1;
      Rprev[j][col]=-1;
    }
  }
}

/* print Rj */
void printRj(int j) {
  int i1;

  i1=Rfirst[j];
	if(i1 == -1) {
		return;
	}

	printf("R%i",j);
  while(i1 != -1) {
    printf(" -> (%i,%i)",j,i1);
    i1=Rnext[j][i1];
  }

  putchar('\n');

}

/* 2D cons check */
void cons_check() {
	unsigned u1,u2;
	unsigned i,j;
	int i1;

	/* laut Algorithmus soll erst eine Liste bestimmt und dann umgetragen werden ! */
	/* S ist eine als Array implementierte Liste der jeweiligen Zeilen */

	/* Ci's fuellen */
  for(j=0; j<=n-m; j++) {
    process_col(j);
		/* Nun ist S und Scount fuer Spalte j gesetzt */
		for(u2=1; u2<=Scount; u2++) {
			insertCi(j,S[u2]);
		}
	}

	/* sortiere alle Kandidaten aus den Listen Cn-m in die Rj ein */

	i=Cfirst[n-m];
	while(i != -1) {
		/* i ist immer die Zeile, n-m die Spalte */
		insertRj(i,n-m);
		i=Cnext[n-m][i];
	}

#ifdef DEBUG
	for(i1=0; i1<=n; i1++)
  	printCi(i1);
	for(i1=0; i1<=n; i1++)
  	printRj(i1);
#endif

	/* Hauptschleife */
	for(i1=n-m-1; i1>=0; i1--) {

		/* bottom up */
		bottom_up(i1);

		/* top down */
		top_down(i1); 

		/* Sortiere Ueberlebende aus Ci nach Ri */
		i=Cfirst[i1];
		while(i != -1) {
			insertRj(i,i1);
			i=Cnext[i1][i];
		}
	}			

#ifdef DEBUG
	for(i1=0; i1<=n; i1++)
  	printCi(i1);

	for(i1=0; i1<=n; i1++)
  	printRj(i1);
#endif

}

/* INIT WAVES */
void init_waves(void) {
	int i1,i2;
	for(i1=0; i1<4096; i1++) {
		for(i2=0; i2<4096; i2++) {
			wave_flags[0][i1][i2]=255;
			wave_flags[1][i1][i2]=255;
			wave_flags[2][i1][i2]=255;
		}
	}
}

void waves(void) {
	int r,c,i;

	/* === wave_mark === */
	/* schritt 1 */
		for(c=0; c<n; c++) {
			r=Cfirst[c];
			while(r != -1) {
				wave_flags[0][r][c]=0;
				wave_flags[1][r][c]=0;
				r=Cnext[c][r];
			}	
		}	
	/* schritt 2 */
	for(c=0; c<n; c++) {
		for(r=0; r<n; r++) {
			if(wave_flags[0][r][c] == 255 && r>0 && wave_flags[0][r-1][c] != 255 && wave_flags[0][r-1][c]<m-1) {
				wave_flags[0][r][c]=wave_flags[0][r-1][c]+1;
				wave_flags[1][r][c]=wave_flags[1][r-1][c];
			}
		}
	}
	/* schritt 3 */
	for(r=0; r<n; r++) {
		for(c=0; c<n; c++) {
			if(wave_flags[0][r][c] == 255 && c>0 && wave_flags[0][r][c-1] != 255 && wave_flags[1][r][c-1]<m-1) {
				wave_flags[0][r][c]=wave_flags[0][r][c-1];
				wave_flags[1][r][c]=wave_flags[1][r][c-1]+1;
			}
		}
	}

	/* === Vergleich mit dem Text === */
	for(r=0; r<n; r++) {
		for(c=0; c<n; c++) {
			if(wave_flags[0][r][c] != 255) {
				if(pattern[wave_flags[0][r][c]][wave_flags[1][r][c]] == text[r][c]) 
					wave_flags[2][r][c]='w';
				else
					wave_flags[2][r][c]='f';
			}		

			/* vorgezogen: schritt 1 aus wave_disc */
			if(wave_flags[2][r][c] == 'f') {
				wave_flags[0][r][c]=0;
				wave_flags[1][r][c]=0;
				wave_flags[2][r][c]='d';
			} else {
				wave_flags[0][r][c]=255;
				wave_flags[1][r][c]=255;
				wave_flags[2][r][c]=255;
			}
		}
	}

	/* === wave_disc === */
	/* schritt 1 schon vorgezogen */
  
	/* schritt 2 */
	for(c=0; c<n; c++) {
		for(r=n-1; r>=0; r--) {
			if(wave_flags[2][r][c] != 'd' && r < n-1 && wave_flags[2][r+1][c] == 'd' && wave_flags[0][r+1][c]<m-1) {
				wave_flags[0][r][c]=wave_flags[0][r+1][c]+1;
				wave_flags[1][r][c]=wave_flags[1][r+1][c];
				wave_flags[2][r][c]='d';
			}
		}
	}

	/* schritt 3 */
	for(r=0; r<n; r++) {
		for(c=n-1; c>=0; c--) {
			if(wave_flags[2][r][c] != 'd' && c < n-1 && wave_flags[2][r][c+1] == 'd' && wave_flags[1][r][c+1]<m-1) {
				wave_flags[0][r][c]=wave_flags[0][r][c+1];
				wave_flags[1][r][c]=wave_flags[1][r][c+1]+1;
				wave_flags[2][r][c]='d';
			}
		}
	}


	/* === Kandidaten rauswerfen === */
	for(c=0; c<n; c++) {
		r=Cfirst[c];
		while(r != -1) {
			if(wave_flags[2][r][c] == 'd') {
				i=r;
				r=Cnext[c][r];
				removeCi(c,i);

			} else {
				r=Cnext[c][r];
			}
		}
	}
}
